var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/MessagePreview.jsx
var MessagePreview_exports = {};
__export(MessagePreview_exports, {
  default: () => MessagePreview_default
});
module.exports = __toCommonJS(MessagePreview_exports);
var import_react = __toESM(require("react"));
var import_json2fragment = require("./utils/fragment/json2fragment");
var import_mark2fragment = require("./utils/fragment/mark2fragment");
var import_markdownParse = require("./utils/parse/markdownParse");
var import_useExternal = __toESM(require("./useExternal"));
var import_lib = require("@kaiheila/kui-lib/lib/index.css");
var import_styles = require("./styles/index.less");
function MessagePreview(props) {
  const {
    type = "card",
    content = [],
    theme = "light",
    external = "",
    hideMoreHeight = 400,
    collapsed = true,
    customMetUserRender,
    customRoleRender,
    customChannelRender,
    customVideoEvents = {},
    customAudioEvents = {},
    customFileEvents = {},
    customButtonClick,
    customImageClick
  } = props;
  const status = (0, import_useExternal.default)(external, {
    js: {
      async: true
    }
  });
  if (external && status !== "ready") {
    return null;
  }
  if (type === "card") {
    return /* @__PURE__ */ import_react.default.createElement("div", { className: `card-message-preview theme-${theme}` }, (0, import_json2fragment.json2fragment)(
      typeof content === "string" ? JSON.parse(content) : content,
      {
        customMetUserRender,
        customRoleRender,
        customChannelRender,
        customVideoEvents,
        customAudioEvents,
        customFileEvents,
        customButtonClick,
        customImageClick,
        hideMoreHeight,
        collapsed
      }
    ));
  }
  if (type === "kmd") {
    return /* @__PURE__ */ import_react.default.createElement("span", { className: `markdown-preview theme-${theme}` }, (0, import_mark2fragment.mark2fragment)((0, import_markdownParse.markdownParse)(content), {
      customMetUserRender,
      customRoleRender,
      customChannelRender
    }));
  }
  return null;
}
var MessagePreview_default = MessagePreview;
