var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/fragment/json2fragment.jsx
var json2fragment_exports = {};
__export(json2fragment_exports, {
  json2fragment: () => json2fragment
});
module.exports = __toCommonJS(json2fragment_exports);
var import_react = __toESM(require("react"));
var import_kui_lib = require("@kaiheila/kui-lib");
var import_MarkdownMessageText = __toESM(require("../../components/MarkdownMessageText"));
var import_emoji = require("../emoji/emoji");
var import_MusicPlayer = __toESM(require("../../components/MusicPlayer"));
var import_CardVideoWrapper = __toESM(require("../../components/CardVideoWrapper"));
function parseModule(module2, cardSize, options) {
  var _a, _b, _c, _d, _e;
  if (typeof module2 === "string") {
    return /* @__PURE__ */ import_react.default.createElement(import_kui_lib.Text, null, /* @__PURE__ */ import_react.default.createElement("span", { dangerouslySetInnerHTML: { __html: (0, import_emoji.printEmoji)(module2) } }));
  } else if (!module2) {
    return "";
  }
  const { elements = [], type, content } = module2;
  let childContent = null;
  let fragment = null;
  switch (type) {
    case "plain-text":
      fragment = /* @__PURE__ */ import_react.default.createElement(import_kui_lib.Text, null, /* @__PURE__ */ import_react.default.createElement("span", { dangerouslySetInnerHTML: { __html: (0, import_emoji.printEmoji)(content) } }));
      break;
    case "header":
      childContent = typeof module2.text === "string" ? /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, (0, import_emoji.printReactEmoji)(module2.text)) : parseModule(module2.text, cardSize, options);
      fragment = /* @__PURE__ */ import_react.default.createElement(import_kui_lib.Title, null, childContent);
      break;
    case "section":
      fragment = /* @__PURE__ */ import_react.default.createElement(
        import_kui_lib.Section,
        {
          accessory: module2.accessory ? parseModule(module2.accessory, cardSize, options) : null,
          mode: module2.mode,
          size: cardSize,
          colume: cardSize === "sm" && module2.accessory && module2.accessory.type === "button" ? true : false
        },
        parseModule(module2.text, cardSize, options)
      );
      break;
    case "paragraph":
      fragment = /* @__PURE__ */ import_react.default.createElement(
        import_kui_lib.Paragraph,
        {
          size: cardSize,
          cols: module2.cols,
          childrens: parseModuleList(module2.fields, cardSize, options)
        }
      );
      break;
    case "container":
      fragment = /* @__PURE__ */ import_react.default.createElement(
        import_kui_lib.Container,
        {
          size: cardSize,
          elements: module2.elements,
          onClickElement: (module3) => {
            if (module3.type === "image" && typeof options.customImageClick === "function")
              options.customImageClick(module3);
          }
        }
      );
      break;
    case "image-group":
      fragment = /* @__PURE__ */ import_react.default.createElement(
        import_kui_lib.Image.Group,
        {
          list: elements,
          onClick: (module3) => {
            if (typeof options.customImageClick === "function")
              options.customImageClick(module3);
          }
        }
      );
      break;
    case "action-group":
      fragment = /* @__PURE__ */ import_react.default.createElement(import_kui_lib.Button.Wrapper, null, parseModuleList(module2.elements, cardSize, options));
      break;
    case "button":
      childContent = parseModule(module2.text, cardSize, options);
      fragment = /* @__PURE__ */ import_react.default.createElement(
        import_kui_lib.Button,
        {
          block: cardSize === "sm",
          type: module2.theme,
          color: module2.color,
          onClick: () => {
            if (typeof options.customButtonClick === "function")
              options.customButtonClick(module2);
          }
        },
        childContent
      );
      break;
    case "context":
      fragment = /* @__PURE__ */ import_react.default.createElement(import_kui_lib.Remark, null, parseModuleList(elements, cardSize, options));
      break;
    case "divider":
      fragment = /* @__PURE__ */ import_react.default.createElement(import_kui_lib.Hr, null);
      break;
    case "file":
      fragment = /* @__PURE__ */ import_react.default.createElement(
        import_kui_lib.File,
        {
          src: module2.src,
          outside: module2.external,
          fileName: module2.title,
          fileSize: module2.size,
          onClickDown: ((_a = options.customFileEvents) == null ? void 0 : _a.onDownload) ? () => {
            options.customFileEvents.onDownload(module2);
          } : void 0
        }
      );
      break;
    case "video":
      fragment = /* @__PURE__ */ import_react.default.createElement(
        import_CardVideoWrapper.default,
        {
          src: module2.src,
          outside: module2.external,
          size: cardSize,
          title: module2.title,
          fileSize: module2.size,
          duration: module2.duration,
          poster: module2.cover,
          onClickPlay: typeof ((_b = options == null ? void 0 : options.customVideoEvents) == null ? void 0 : _b.onPlay) === "function" ? () => {
            options.customVideoEvents.onPlay(module2);
          } : void 0,
          onClickDown: typeof ((_c = options == null ? void 0 : options.customVideoEvents) == null ? void 0 : _c.onDownload) === "function" ? () => {
            options.customVideoEvents.onDownload(module2);
          } : void 0
        }
      );
      break;
    case "audio":
      fragment = /* @__PURE__ */ import_react.default.createElement(
        import_MusicPlayer.default,
        {
          src: module2.src,
          outside: module2.external,
          fileName: module2.title,
          fileSize: module2.size,
          controls: cardSize !== "sm",
          duration: module2.duration,
          icon: module2.cover,
          id: `${module2 == null ? void 0 : module2.src}${module2 == null ? void 0 : module2.title}`,
          canDownload: module2.canDownload,
          onClickPlay: typeof ((_d = options == null ? void 0 : options.customAudioEvents) == null ? void 0 : _d.onPlay) === "function" ? () => {
            options.customAudioEvents.onPlay(module2);
          } : void 0,
          onClickDown: typeof ((_e = options == null ? void 0 : options.customAudioEvents) == null ? void 0 : _e.onDownload) === "function" ? () => {
            options.customAudioEvents.onDownload(module2);
          } : void 0
        }
      );
      break;
    case "countdown":
      if (module2.mode === "hour") {
        fragment = /* @__PURE__ */ import_react.default.createElement(import_kui_lib.CountDown.Hour, { endTime: module2.endTime, size: cardSize });
      } else if (module2.mode === "day") {
        fragment = /* @__PURE__ */ import_react.default.createElement(import_kui_lib.CountDown.Day, { endTime: module2.endTime });
      } else {
        const { startTime = 0, endTime = 0 } = module2;
        let duration = endTime - startTime;
        fragment = /* @__PURE__ */ import_react.default.createElement(import_kui_lib.CountDown, { startTime, duration });
      }
      break;
    case "kmarkdown":
      fragment = /* @__PURE__ */ import_react.default.createElement(import_MarkdownMessageText.default, { content, options });
      break;
  }
  return fragment;
}
function parseModuleList(moduleList, cardSize, options) {
  moduleList = moduleList || [];
  return moduleList.map((module2, i) => {
    return /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, { key: i }, parseModule(module2, cardSize, options));
  });
}
function json2fragment(cardList, options) {
  return cardList.map((card, i) => {
    const { modules = [], color, size, theme } = card;
    return /* @__PURE__ */ import_react.default.createElement(
      import_kui_lib.Card,
      {
        color,
        theme,
        size,
        key: i,
        hideMoreHeight: options.hideMoreHeight,
        collapsed: options.collapsed
      },
      parseModuleList(modules, size, options)
    );
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  json2fragment
});
