var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/fragment/mark2fragment.jsx
var mark2fragment_exports = {};
__export(mark2fragment_exports, {
  mark2fragment: () => mark2fragment
});
module.exports = __toCommonJS(mark2fragment_exports);
var import_react = __toESM(require("react"));
var import_emoji = require("../emoji/emoji");
var import_CodeblockNode = __toESM(require("../../components/CodeblockNode"));
var import_SpoilerNode = __toESM(require("../../components/SpoilerNode"));
function ChannelLinkNode(props) {
  const { channel_id, options } = props;
  const customChannelRender = options == null ? void 0 : options.customChannelRender;
  if (typeof customChannelRender === "function") {
    return customChannelRender(channel_id);
  }
  return `#频道id:${channel_id}`;
}
function MentionUserNode(props) {
  const { user_id, options } = props;
  const customMetUserRender = options == null ? void 0 : options.customMetUserRender;
  if (typeof customMetUserRender === "function") {
    return customMetUserRender(user_id);
  }
  return `@用户id:${user_id}`;
}
function MentionRoleNode(props) {
  const { role_id, options } = props;
  const customRoleRender = options == null ? void 0 : options.customRoleRender;
  if (typeof customRoleRender === "function") {
    return customRoleRender(role_id);
  }
  return `@角色id:1 ${role_id}`;
}
function getCustomEmojiUrl(id) {
  return `https://img.kaiheila.cn/emojis/${id}.png`;
}
function parse(children = [], options) {
  return children.map((item, i) => {
    const { type, tagName: TagName, content, attrs, children: children2 } = item;
    let fragment = null;
    switch (type) {
      case "tag":
        fragment = /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, { key: i }, parseTag(item, options));
        break;
      case "control":
        fragment = /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, { key: i }, parse(children2, options));
        break;
      case "text":
        fragment = /* @__PURE__ */ import_react.default.createElement(
          "span",
          {
            key: i,
            dangerouslySetInnerHTML: { __html: (0, import_emoji.printEmoji)(content) }
          }
        );
        break;
      default:
        console.error("未识别的类型");
    }
    return fragment;
  });
}
function mark2fragment(markdown, options) {
  return parse(markdown.children, options);
}
function parseTag(item, options) {
  const { type, tagName: TagName, content, attrs, children } = item;
  let fragment = null;
  const childrenContent = children ? children.map((c) => c.content || "").join("") : "";
  switch (TagName) {
    case "a":
      let href = attrs.href || "";
      if (href.startsWith("https://") || href.startsWith("http://")) {
        fragment = /* @__PURE__ */ import_react.default.createElement("a", { className: "text-link", target: "_blank", href: attrs.href }, children && parse(children));
      } else {
        fragment = children && parse(children);
      }
      break;
    case "emj":
      fragment = /* @__PURE__ */ import_react.default.createElement("img", { className: "emoji custom", src: getCustomEmojiUrl(attrs.join("")) });
      break;
    case "spl":
      fragment = /* @__PURE__ */ import_react.default.createElement(import_SpoilerNode.default, null, children && parse(children));
      break;
    case "chn":
      fragment = /* @__PURE__ */ import_react.default.createElement(ChannelLinkNode, { channel_id: childrenContent, options });
      break;
    case "met":
      fragment = /* @__PURE__ */ import_react.default.createElement(MentionUserNode, { user_id: childrenContent, options });
      break;
    case "rol":
      fragment = /* @__PURE__ */ import_react.default.createElement(MentionRoleNode, { role_id: childrenContent, options });
      break;
    case "code":
      fragment = /* @__PURE__ */ import_react.default.createElement("code", { className: "line" }, children && children.map((item2) => item2.content || "").join(""));
      break;
    case "codeblock":
      fragment = /* @__PURE__ */ import_react.default.createElement(import_CodeblockNode.default, { code: { text: childrenContent, lang: attrs[0] } });
      break;
    case "font":
      fragment = /* @__PURE__ */ import_react.default.createElement("span", { className: `kmd-font ${attrs == null ? void 0 : attrs.theme}  ${attrs == null ? void 0 : attrs.size}` }, children && parse(children, options));
      break;
    default:
      fragment = /* @__PURE__ */ import_react.default.createElement(TagName, { ...attrs }, children && parse(children, options));
  }
  return fragment;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  mark2fragment
});
