import React, { useEffect, useRef, useState } from 'react';
import { json2fragment } from "./utils/fragment/json2fragment";
import { mark2fragment } from "./utils/fragment/mark2fragment";
import { markdownParse } from "./utils/parse/markdownParse";
import useExternal from "./useExternal";
import '@kaiheila/kui-lib/lib/index.css';
import "./styles/index.less";
function MessagePreview(props) {
  var _props$type = props.type,
    type = _props$type === void 0 ? 'card' : _props$type,
    _props$content = props.content,
    content = _props$content === void 0 ? [] : _props$content,
    _props$theme = props.theme,
    theme = _props$theme === void 0 ? 'light' : _props$theme,
    _props$external = props.external,
    external = _props$external === void 0 ? '' : _props$external,
    _props$hideMoreHeight = props.hideMoreHeight,
    hideMoreHeight = _props$hideMoreHeight === void 0 ? 400 : _props$hideMoreHeight,
    _props$collapsed = props.collapsed,
    collapsed = _props$collapsed === void 0 ? true : _props$collapsed,
    customMetUserRender = props.customMetUserRender,
    customRoleRender = props.customRoleRender,
    customChannelRender = props.customChannelRender,
    _props$customVideoEve = props.customVideoEvents,
    customVideoEvents = _props$customVideoEve === void 0 ? {} : _props$customVideoEve,
    _props$customAudioEve = props.customAudioEvents,
    customAudioEvents = _props$customAudioEve === void 0 ? {} : _props$customAudioEve,
    _props$customFileEven = props.customFileEvents,
    customFileEvents = _props$customFileEven === void 0 ? {} : _props$customFileEven,
    customButtonClick = props.customButtonClick,
    customImageClick = props.customImageClick;
  var status = useExternal(external, {
    js: {
      async: true
    }
  });

  // markdown解析方法加载成功后再渲染组件
  if (external && status !== 'ready') {
    return null;
  }
  if (type === 'card') {
    return /*#__PURE__*/React.createElement("div", {
      className: "card-message-preview theme-".concat(theme)
    }, json2fragment(typeof content === 'string' ? JSON.parse(content) : content, {
      customMetUserRender: customMetUserRender,
      customRoleRender: customRoleRender,
      customChannelRender: customChannelRender,
      customVideoEvents: customVideoEvents,
      customAudioEvents: customAudioEvents,
      customFileEvents: customFileEvents,
      customButtonClick: customButtonClick,
      customImageClick: customImageClick,
      hideMoreHeight: hideMoreHeight,
      collapsed: collapsed
    }));
  }
  if (type === 'kmd') {
    return /*#__PURE__*/React.createElement("span", {
      className: "markdown-preview theme-".concat(theme)
    }, mark2fragment(markdownParse(content), {
      customMetUserRender: customMetUserRender,
      customRoleRender: customRoleRender,
      customChannelRender: customChannelRender
    }));
  }
  return null;
}
export default MessagePreview;