import React from 'react';
import { Video } from '@kaiheila/kui-lib';
function CardVideoWrapper(props) {
  var fileSize = props.fileSize,
    src = props.src,
    external = props.external,
    title = props.title,
    size = props.size,
    duration = props.duration,
    cover = props.cover,
    onClickPlay = props.onClickPlay,
    onClickDown = props.onClickDown;
  var downloadMusic = function downloadMusic() {
    var a = document.createElement('a');
    a.href = src;
    a.setAttribute('target', '_blank');
    a.rel = 'noopener noreferror';
    a.click();
  };
  return /*#__PURE__*/React.createElement(Video, {
    src: src,
    outside: external,
    size: size,
    title: title,
    fileSize: fileSize,
    duration: duration,
    poster: cover,
    onClickPlay: typeof onClickPlay === 'function' ? function () {
      return onClickPlay(props);
    } : undefined,
    status: 'done',
    onClickDown: typeof onClickDown === 'function' ? function () {
      return onClickDown(props);
    } : downloadMusic
  });
}
export default CardVideoWrapper;