import React from 'react';
import twemoji from 'twemoji';
var options = {
  decodeEntities: true,
  transform: function transform(node) {}
};
export function printReactEmoji(str) {
  if (!str) {
    return '';
  }
  str = encodeLocalHtml("".concat(str));
  str = twemoji.parse(str, {
    folder: 'svg',
    ext: '.svg'
  });
  return /*#__PURE__*/React.createElement("span", {
    dangerouslySetInnerHTML: {
      __html: str
    }
  });
}
export function encodeLocalHtml() {
  var sHtml = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return sHtml.replace(/[<>&"]/g, function (c) {
    return {
      '<': '&lt;',
      '>': '&gt;',
      '&': '&amp;',
      '"': '&quot;',
      "'": '&#39;',
      '&#8238;': '',
      '&#8207;': ''
    }[c];
  });
}

//不转义&nbsp;其他转义
export function htmlEncode() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var s = '';
  if (str.length == 0) return '';
  s = str.replace(/</g, '&lt;');
  s = s.replace(/>/g, '&gt;');
  s = s.replace(/\'/g, '&#39;');
  s = s.replace(/\"/g, '&quot;');
  s = s.replace(/&#8238;/g, '');
  s = s.replace(/&#8207;/g, '');
  return s;
}
export function printEmoji(str) {
  var encodenbsp = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  if (!str) {
    return '';
  }
  str = "".concat(str);
  if (encodenbsp) {
    str = encodeLocalHtml(str);
  } else {
    str = htmlEncode(str);
  }
  str = twemoji.parse(str, {
    folder: 'svg',
    ext: '.svg'
  });
  return str;
}